<template lang="pug">
.container
  .container-fuild
    .text-right
      button(@click="signOut") SignOut
  div
    h2 Create User

    validation-observer(ref="validator")
      b-form(
        @reset='onReset'
        )
        validation-provider(name="Email" rules="required|email" v-slot="{ errors }")
          b-form-group#input-group-1(
            label='Email:'
            label-for='input-name'
            )
            b-form-input#input-name(
              v-model='form.email'
              type='email'
              required=''
              placeholder='Enter Email'
              )
            transition(name="fast-fade")
              .text-danger.mt-1(v-if="errors[0]") {{ errors[0] }}

        validation-provider(name="Password" rules="required" v-slot="{ errors }")
          b-form-group#input-group-1(
            label='Password:'
            label-for='input-name'
            )
            b-form-input#input-name(
              v-model='form.password'
              type='password'
              required=''
              placeholder='Enter Password'
              )
            transition(name="fast-fade")
              .text-danger.mt-1(v-if="errors[0]") {{ errors[0] }}

        validation-provider(name="name" rules="required" v-slot="{ errors }")
          b-form-group#input-group-1(
            label='Name:'
            label-for='input-name'
            )
            b-form-input#input-name(
              v-model='form.name'
              type='text'
              required=''
              placeholder='Enter Name'
              )
            transition(name="fast-fade")
              .text-danger.mt-1(v-if="errors[0]") {{ errors[0] }}

        validation-provider(name="lastname" rules="required" v-slot="{ errors }")
          b-form-group#input-group-1(
            label='Lastname:'
            label-for='input-lastname'
            )
            b-form-input#input-lastname(
              v-model='form.lastname'
              type='text'
              required=''
              placeholder='Enter Lastname'
              )
            transition(name="fast-fade")
              .text-danger.mt-1(v-if="errors[0]") {{ errors[0] }}

        validation-provider(name="tel" rules="required" v-slot="{ errors }")
          b-form-group(
            label='Tel:'
            label-for='input-tel'
            )
            b-form-input#input-tel(
              v-model='form.tel'
              type='text'
              required=''
              placeholder='Enter Lastname'
              )
            transition(name="fast-fade")
              .text-danger.mt-1(v-if="errors[0]") {{ errors[0] }}

        validation-provider(name="age" rules="required" v-slot="{ errors }")
          b-form-group(
            label='Age:'
            label-for='input-age'
            )
            b-form-input#input-age(
              v-model='form.age'
              type='text'
              required=''
              placeholder='Enter Age'
              )
            transition(name="fast-fade")
              .text-danger.mt-1(v-if="errors[0]") {{ errors[0] }}

        validation-provider(name="address" rules="required" v-slot="{ errors }")
          b-form-group(
            label='Address:'
            label-for='input-address'
            )
            b-form-textarea#input-address(
              v-model='form.address'
              type='text'
              required=''
              placeholder='Enter Address'
              )
            transition(name="fast-fade")
              .text-danger.mt-1(v-if="errors[0]") {{ errors[0] }}

        b-button.mr-2(
          type='button'
          variant='primary'
          @click='onSubmit'
          ) Add
        b-button(
          type='reset'
          variant='danger'
          ) Reset
  hr
  h2 User List
  ul.detail-list(:key='key', v-for='(contact, key) in contacts')
    li(v-if='updateKey === key')
      .wrap-detail.w-100
        validation-observer(ref="validatorUpdate")
          b-form
            validation-provider(name="name" rules="required" v-slot="{ errors }")
              b-form-group#input-group-1(
                label='Name:'
                label-for='input-name'
                )
                b-form-input#input-name(
                  v-model='update.name'
                  type='text'
                  required=''
                  placeholder='Enter Name'
                  )
                transition(name="fast-fade")
                  .text-danger.mt-1(v-if="errors[0]") {{ errors[0] }}

            validation-provider(name="lastname" rules="required" v-slot="{ errors }")
              b-form-group#input-group-1(
                label='Lastname:'
                label-for='input-lastname'
                )
                b-form-input#input-lastname(
                  v-model='update.lastname'
                  type='text'
                  required=''
                  placeholder='Enter Lastname'
                  )
                transition(name="fast-fade")
                  .text-danger.mt-1(v-if="errors[0]") {{ errors[0] }}

            validation-provider(name="tel" rules="required" v-slot="{ errors }")
              b-form-group(
                label='Tel:'
                label-for='input-tel'
                )
                b-form-input#input-tel(
                  v-model='update.tel'
                  type='text'
                  required=''
                  placeholder='Enter Lastname'
                  )
                transition(name="fast-fade")
                  .text-danger.mt-1(v-if="errors[0]") {{ errors[0] }}

            validation-provider(name="age" rules="required" v-slot="{ errors }")
              b-form-group(
                label='Age:'
                label-for='input-age'
                )
                b-form-input#input-age(
                  v-model='update.age'
                  type='text'
                  required=''
                  placeholder='Enter Age'
                  )
                transition(name="fast-fade")
                  .text-danger.mt-1(v-if="errors[0]") {{ errors[0] }}

            validation-provider(name="address" rules="required" v-slot="{ errors }")
              b-form-group(
                label='Address:'
                label-for='input-address'
                )
                b-form-textarea#input-address(
                  v-model='update.address'
                  type='text'
                  required=''
                  placeholder='Enter Address'
                  )
                transition(name="fast-fade")
                  .text-danger.mt-1(v-if="errors[0]") {{ errors[0] }}

          button.btn.btn-primary(@click='updateContact(update)') Update
    li(v-else='')
      .d-flex.justify-content-between
        .wrap-contect
          p {{user.uid == key ? 'My Profile' : ''}} {{contact.name}} {{contact.lastname}} {{contact.tel}} {{contact.age}} {{contact.address}}
        .wrap-actions
          button.btn.btn-primary(@click='setUpdateContact(key, contact)') Edit
          button.btn.btn-danger.ml-2(@click='deleteContact(key)') Delete

</template>

<script>
import _ from 'lodash'
import firebase from 'firebase/app'
import 'firebase/auth'
import 'firebase/firestore'
import 'firebase/database'

var database = firebase.database()
var contactRef = database.ref('/contacts')

export default {
  name: 'MainPage',
  data () {
    return {
      contacts: {},
      user: {},
      form: {
        email: '',
        password: '',
        name: '',
        lastname: '',
        tel: '',
        age: '',
        address: ''
      },
      update: {
        name: '',
        lastname: '',
        tel: '',
        age: '',
        address: ''
      },
      updateKey: ''
    }
  },

  beforeCreate () {
    firebase.auth().onAuthStateChanged((user) => {
      if (!user) {
        this.$router.replace('/')
        // alert("You don't have a permission")
      }
    })
  },
  methods: {
    signOut () {
      firebase
        .auth()
        .signOut()
        .then(() => {
          this.$router.replace('/')
        })
    },

    // Connect Username
    async onSubmit () {
      const isFormValid = await this.$refs.validator.validate()
      if (!isFormValid) return
      let data = {
        name: this.form.name,
        lastname: this.form.lastname,
        tel: this.form.tel,
        age: this.form.age,
        address: this.form.address
      }

      try {
        var { user } = await firebase
          .auth()
          .createUserWithEmailAndPassword(this.form.email, this.form.password)
        // signout
        contactRef.child(user.uid).set(data)
      } catch (error) {
        console.log(error.message)
      }
      // this.form = {
      //   name: '',
      //   lastname: '',
      //   tel: '',
      //   age: '',
      //   address: ''
      // }
    },
    onReset (evt) {
      evt.preventDefault()
      // Reset our form values
      this.form = {
        name: '',
        lastname: '',
        tel: '',
        age: '',
        address: ''
      }
    },
    setUpdateContact (key, contact) {
      this.updateKey = key
      this.update = _.cloneDeep(contact)
    },
    updateContact (update) {
      contactRef.child(this.updateKey).update({ ...update })
      this.updateKey = ''
      // this.update = {
      //   name: '',
      //   lastname: '',
      //   tel: '',
      //   age: '',
      //   address: ''
      // }
    },
    deleteContact (key) {
      contactRef.child(key).remove()
    }
  },
  mounted () {
    contactRef.on('value', (snapshot) => {
      this.contacts = snapshot.val()
    })
    let vm = this
    firebase.auth().onAuthStateChanged(function (user) {
      if (user) {
        vm.user = user
      }
    })
  }
}
</script>

<style lang="css" scoped>
.detail-list {
  list-style: none;
}
</style>
